import unittest
import six

from ...backends.base import BaseAuth
from ..strategy import _TestStrategy
from ..models import TestStorage


class BrokenBackendAuth(BaseAuth):
    name = 'broken'


class BrokenBackendTest(unittest.TestCase):
    def setUp(self):
        self.backend = BrokenBackendAuth(_TestStrategy(TestStorage))

    def tearDown(self):
        self.backend = None

    def test_auth_url(self):
        with six.assertRaisesRegex(self, NotImplementedError,
                                     'Implement in subclass'):
            self.backend.auth_url()

    def test_auth_html(self):
        with six.assertRaisesRegex(self, NotImplementedError,
                                     'Implement in subclass'):
            self.backend.auth_html()

    def test_auth_complete(self):
        with six.assertRaisesRegex(self, NotImplementedError,
                                     'Implement in subclass'):
            self.backend.auth_complete()

    def test_get_user_details(self):
        with six.assertRaisesRegex(self, NotImplementedError,
                                     'Implement in subclass'):
            self.backend.get_user_details(None)
